﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using J2534;
using Microsoft.Win32;
using System.Runtime.InteropServices;
using System.Threading;

namespace E55Tool
{
    /*
     *  E55Tool by The1 pcmhacking.net
     *  J2534 Library by PCMHammer https://github.com/LegacyNsfw/PcmHacks/wiki/PCM-Hammer
     * 
     */

    class Program
    {

        static void Main(string[] args)
        {

            // Find Devices in Registry
            List<J2534.J2534Device> installedDLLs = new List<J2534.J2534Device>();

            string PASSTHRU_REGISTRY_PATH = "Software\\PassThruSupport.04.04";
            RegistryKey myKey = Registry.LocalMachine.OpenSubKey(PASSTHRU_REGISTRY_PATH, false);
            string[] devices = myKey.GetSubKeyNames();

            foreach (string device in devices)
            {
                J2534.J2534Device tempDevice = new J2534.J2534Device();
                RegistryKey deviceKey = myKey.OpenSubKey(device);

                if ((deviceKey == null))
                {
                    continue; //Skip device... its empty
                }

                tempDevice.FunctionLibrary = (string)deviceKey.GetValue("FunctionLibrary", "");
                tempDevice.Name = (string)deviceKey.GetValue("Name", "");

                installedDLLs.Add(tempDevice);
                
            }



            Console.WriteLine("\nE55Tool v1.00 by The1 pcmhacking.net");
            Console.WriteLine("\nJ2534 Library by PCMHammer https://github.com/LegacyNsfw/PcmHacks/wiki/PCM-Hammer \n");

            
            for (int i = 0; i < installedDLLs.Count; i++) {
                Console.WriteLine(i+":" + installedDLLs[i]);
            };
            Console.WriteLine("Input Device Number:");

            // Setup Library for use
            PassThruMsg TempMsg = new PassThruMsg();
            J2534.J2534DllWrapper E55Tool = new J2534.J2534DllWrapper();


            // Load Library
            int dllselect = Convert.ToInt32(Console.ReadLine());
            string tooldll = Convert.ToString((installedDLLs[dllselect].FunctionLibrary));
            Console.WriteLine("Cable dll File: "+ tooldll);
            E55Tool.LoadJ2534Library(tooldll);
            Console.WriteLine("Loading Library\n");


            // Variables
            uint deviceID = 1;
            int ChannelID = 1;
            int Timeout = 1000;


            // Open Device
            E55Tool.Open(IntPtr.Zero, ref deviceID);
            Console.WriteLine("Connection Open");


            // Connect to Device
            E55Tool.Connect(deviceID, J2534.ProtocolID.ISO15765, J2534.ConnectFlag.CAN_ID_BOTH, J2534.BaudRate.CAN_500000, ref deviceID);
            Console.WriteLine("Connect");


            // Setup Filters
            int FilterID = 1;
            PassThruMsg maskMsg = new PassThruMsg(J2534.ProtocolID.ISO15765, J2534.TxFlag.ISO15765_FRAME_PAD, new byte[] { 0xFF, 0xFF, 0xFF, 0xFF }); // FF block 00 open all traffic
            PassThruMsg patternMsg = new PassThruMsg(J2534.ProtocolID.ISO15765, J2534.TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xE8 }); // Only Show this
            PassThruMsg flowControlMsg = new PassThruMsg(J2534.ProtocolID.ISO15765, J2534.TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x00, 0x00 }); // flow control message
            IntPtr maskMsgPtr = maskMsg.ToIntPtr();
            IntPtr PatternPtr = patternMsg.ToIntPtr();
            IntPtr flowControlMsgPtr = flowControlMsg.ToIntPtr();
            E55Tool.StartMsgFilter(ChannelID, FilterID, maskMsgPtr, PatternPtr, flowControlMsgPtr, ref FilterID);
            Console.WriteLine("Setup Filters\n");


            // Write Messages 
            int NumMsgstoWrite = 1;
            IntPtr txMsgs = Marshal.AllocHGlobal((int)(Marshal.SizeOf(typeof(PassThruMsg)) * NumMsgstoWrite)); // Allocate Memory
            PassThruMsg WriteMsg = new PassThruMsg(J2534.ProtocolID.ISO15765, J2534.TxFlag.ISO15765_FRAME_PAD, new byte[] { 0x00, 0x00, 0x07, 0xE0, 0x1A, 0x90 }); // Message to send
            txMsgs = WriteMsg.ToIntPtr(); // Put message into memory
            E55Tool.WriteMsgs((int)ChannelID, txMsgs, ref NumMsgstoWrite, Timeout); // Write message to bus
            TempMsg = txMsgs.AsMsgList(1).Last(); //Read Buffer
            Console.WriteLine("Message Sent: " + BitConverter.ToString(TempMsg.GetBytes()).Replace("-", " ") + "\n");
            E55Tool.Ioctl(ChannelID, 8, IntPtr.Zero, IntPtr.Zero); //Clear Buffers after Send


            // Read Messages
            for (int i = 0; i < 2; i++)
            {
                
                int NumMsgstoRead = 1;
                IntPtr rxMsgs = Marshal.AllocHGlobal((int)(Marshal.SizeOf(typeof(PassThruMsg)) * NumMsgstoRead));
                E55Tool.ReadMsgs(ChannelID, rxMsgs, ref NumMsgstoRead, Timeout);
                TempMsg = rxMsgs.AsMsgList(1).Last();
                Console.WriteLine("Read Message: " + BitConverter.ToString(TempMsg.GetBytes()).Replace("-", " "));
            };
            

            // Close Filters
            E55Tool.StopMsgFilter(ChannelID, FilterID);
            Console.WriteLine("\nClear Filters");


            // Close Device
            E55Tool.Close(deviceID);
            Console.WriteLine("Close Device Connection");


            //Free Library
            E55Tool.FreeLibrary();
            Console.WriteLine("Close Library");




        }
    }
}
